=== debian/changelog ===
sphinxsearch (2.8.2-1) experimental; urgency=medium

  * New upstream release.
  * New upstream: manticore.
  * Rebase patches.
  * Use pkgconf to find dependencies.
  * Disable Galera support.
  * Don’t set rpath.
  * Build with expat
  * Disable tests.
  * Add missing build dependencies on bison, flex, pkgconf, unixodbc-dev.

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 11 Dec 2021 09:57:00 +0100
